LISTING 2: DWDLL.PAS
This dynamic link library locates DebugWin's window and sends debugging messages to it. Because it's implemented as a DLL, you can call it from WinApps written in any language.

{$S-,R-}

library dwDLL;

uses
  Strings, WinTypes, WinProcs;

const
  dwTitle        = 'Debug Window';
  wmsDebugString = 'wm_DebugString';
  WeLoadedIt     : Boolean = False;

var
  wm_DebugString : Word;
  SaveExitProc   : Pointer;

  procedure dwSendMessage(Msg, wParam : Word;
    lParam : LongInt); export;
  const
    DebugWindow : hWnd = 0;
    Retried     : Boolean = False;
  begin
    if (DebugWindow = 0) and not IsWindow(DebugWindow)
      then begin
      DebugWindow := FindWindow('TPWinCrt', dwTitle);
      if (DebugWindow = 0) and not Retried then begin
        WinExec('DEBUGWIN.EXE', sw_ShowNoActivate);
        DebugWindow := FindWindow('TPWinCrt', dwTitle);
        WeLoadedIt := (DebugWindow <> 0);
        Retried := True;
      end;
    end;

    if DebugWindow <> 0 then
      if Msg = wm_Destroy then
        PostMessage(DebugWindow, Msg, wParam, lParam)
      else
        SendMessage(DebugWindow, Msg, wParam, lParam);
  end;

  procedure dwWriteBuf(Msg : PChar; Count : Word);
    export;
  begin
    dwSendMessage(wm_DebugString, Count, LongInt(Msg));
  end;

  procedure dwWrite(Msg : PChar); export;
  begin
    dwWriteBuf(Msg, StrLen(Msg));
  end;

  procedure dwWriteLn(Msg : PChar); export;
  begin
    dwWrite(Msg);
    dwWrite(^M^J);
  end;

  procedure dwWriteChar(Ch : Char); export;
  const
    ChCopy : Char = #0;
  begin
    ChCopy := Ch;
    dwWriteBuf(@Ch, 1);
  end;

  procedure OurExitProc; far;
  begin
    ExitProc := SaveExitProc;
    if (ExitCode <> wep_System_Exit) and WeLoadedIt
      then
      dwSendMessage(wm_Destroy, 0, 0);
  end;

exports
  dwSendMessage index 1,
  dwWriteBuf    index 2,
  dwWrite       index 3,
  dwWriteLn     index 4,
  dwWriteChar   index 5;

begin
  wm_DebugString := RegisterWindowMessage(wmsDebugString);
  SaveExitProc := ExitProc;
  ExitProc     := @OurExitProc;
end.
